#!/bin/bash

#
# Script to run regression tests on the vpl
#

ccheck() {
    ../../ccheck -I .. -dom-p "$@"
}

# auxiliary file
name="$(basename $0).log"

function die() {
    rm -f "${name}"
    echo $1 >&2
    exit 1
}

cd "$(dirname $0)" || exit 1

if [ -f "${name}" ] ; then
    die "Please, remove file ${name}..."
fi
touch "${name}" || die "can't write file ${name} ?"

nbfails=0
for f in *.c ; do
    echo "ccheck $f"
    ccheck "${f}" > "${name}" 2>&1 || die "error on ccheck ${f}"
    if grep "¡ALARMS!" "${name}" ; then
        echo "# $f => KO"
        cat "${name}"
        ((nbfails++))
    fi
done

rm -f "${name}"

if [ "${nbfails}" = "0" ]; then
    echo "vpl tests ok" 
    exit 0
else
    echo "!!! vpl tests ko !!!" 
    echo "${nbfails} test(s) fail"
    exit 1
fi
    
