#include "verasco.h"
#include "math-stubs.h"

typedef double (*fun)(double);

static double id(double x)
{
  return x;
}

static double square(double x)
{
  return x * x;
}

fun functions[] = { id, square, fabs, sqrt };
#define N ((sizeof(functions)) / (sizeof(functions[0])))

static double integr(fun f, double low, double high, int n)
{
  double h, x, s;
  int i;

  h = (high - low) / n;
  s = 0;
  for (i = n, x = low; i > 0; i--, x += h) {
	s += f(x);
  }
  return s * h;
}

int main(void)
{
  for (int i = 0; i < any_int(); ++i) {
    double m = any_double();
    verasco_assume( 1.0 <= m );
    int n = any_int();
    verasco_assume( 0 < n );
    integr(functions[i % N], 0.0, m, n);
  }
  return 0;
}
