#include"verasco.h"

int main() {
  int a = any_int(), b = any_int();

  verasco_assume(0 <= b && b <= 1000000000);

  if(3 < a && a < 5 && b % 4 == 0) {
    // The interval domain tells the congruence domain that a == 4
    verasco_assert(b % a == 0);
  }

  if(b % 4 == 0 && b % 4 == a) {
    // The congruence domain tells the interval domain that a == 0
    verasco_assert(a >= 0);
    verasco_assert(a <= 0);
  }

  if(13 <= b && b <= 19) {
    if(b % 3 == 2) {
      // When then congruence domain learns than b % 3 == 2, it sends a message to
      // the interval domain, which refines the interval for b.
      verasco_assert(14 <= b && b <= 17);
    }
  }

  if(50 <= b && b <= 56) {
    if(b % 13 == 7) {
      // Same example as before, but we deduce a contradiction.
      verasco_assert(0);
    }
  }

  if(b % 3 == 2) {
    if(13 <= b && b <= 19) {
      // When then interval domain learns than b is in [13, 19], it asks the congr
      // domain whether it can reduce this interval.
      verasco_assert(14 <= b && b <= 17);
    }
  }

  if(b % 13 == 7) {
    if(50 <= b && b <= 56) {
      // Same example as before, but we deduce a contradiction.
      verasco_assert(0);
    }
  }

  // Same as previous examples, but both pieces of information are deduced at the
  // same time.
  if(13 <= b && b <= 19 && b % 3 == 2) {
    verasco_assert(14 <= b && b <= 17);
  }

  if(50 <= b && b <= 56 && b % 13 == 7) {
    verasco_assert(0);
  }

  // Used in a loop.
  for(int i = 2; i < 16; i += 5)
    verasco_assert(i <= 12);


  return 0;
}
